(define-module (alterator socket)
    :export (make-server-socket
	     make-client-socket))

(define (bind-error)
  (error "Adress already in use"))

(define (bind-socket s socket-name)
  (catch 'system-error
	 (lambda()
	   (bind s AF_UNIX socket-name))
	 (lambda (key name fmt args errno-list)
	   (if (and (string=? name "bind")
		    (member EADDRINUSE errno-list))
	     (catch 'system-error
		    (lambda()
		      (connect s AF_UNIX socket-name)
		      (bind-error)); oops ... something uses this socket
		    (lambda args ;;ok remove and rebind
		      (delete-file socket-name)
		      (bind s AF_UNIX socket-name)))
	     (bind-error)))))

(define (make-server-socket socket-name socket-user socket-group)
  (let ((s (socket PF_UNIX SOCK_STREAM 0))
	(uid (if (string? socket-user) (passwd:uid (getpwnam socket-user)) -1))
	(gid (if (string? socket-group) (group:gid (getgrnam socket-group)) -1)))
    (catch
      #t
      (lambda()
	(bind-socket s socket-name)
	(listen s 10)
	(chown socket-name uid gid)
	(chmod socket-name #o660)
	s)
      (lambda args
	(close-port s)
	(apply throw args)))))

(define (make-client-socket socket-name)
  (let ((s (socket PF_UNIX SOCK_STREAM 0)))
    (catch
      #t
      (lambda()
	(connect s AF_UNIX socket-name)
	s)
      (lambda args
	(close-port s)
	(apply throw args)))))

